package com.java.beans;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Unmarshaller;

import org.apache.commons.lang.exception.ExceptionUtils;

import com.beans.test.Parent;
import com.grapecity.documents.excel.FindLookIn;
import com.grapecity.documents.excel.FindOptions;
import com.grapecity.documents.excel.IRange;
import com.grapecity.documents.excel.IWorksheet;
import com.grapecity.documents.excel.Workbook;
import com.test.beans.TableV3;
import com.test.functions.FilterRowCondition;
import com.test.functions.HyperLinkFunction;

import lombok.extern.slf4j.Slf4j;

@Slf4j
public class MyApp {

	public static void main(String[] args) {
		processTemplateTwo();
	}
	
	public static void processTemplateTwo() {
		String outputPath = "output/sendforpoc_output.xlsx";
		 TableV3 dd = getDataSourcesFromXml(TableV3.class, "data/dataV3.xml");
			Parent ds = getDataSourcesFromXml(Parent.class, "data/sample-data.xml");
			Workbook.AddCustomFunction(new HyperLinkFunction());
			Workbook.AddCustomFunction(new FilterRowCondition());
			Workbook workbook= new Workbook();
			/*workbook.open(MyApp.class.getClassLoader().getResourceAsStream("xlsx/sendforpoc.xlsx"));
			IWorksheet activeSheet = workbook.getWorksheets().get("Data");
			workbook.addDataSource("dd", dd);
			workbook.addDataSource("ds", ds);*/
			
			workbook.open(MyApp.class.getClassLoader().getResourceAsStream("xlsx/tosendforpoc.xlsx"));
			//IWorksheet activeSheet = workbook.getWorksheets().get("Data");
			//workbook.addDataSource("dd", dd);
			workbook.addDataSource("ds", ds);
			/**
			 * Below call require for convert string closing symbol "  
			 */
			//converstionFun(activeSheet,"HyperLinkFun");
			
			log.info("Process Template begin");
			workbook.processTemplate();
			
			log.info("Process Template complete");
			/**
			 * Again need to call processTemplate for conversation of {{==HyperLinkFun(...)}} to =HyperLinkFun(...)  This data from rendered by the dataSource(ds)
			 */
			//workbook.processTemplate();
			
			/**
			 * If I will not call below function then.. cell value will show like =FilterRow(..)
			 * 
			 * After call of below function the corresponding value will set otherwise not
			 */
			workbook.calculate();
			//propFun(activeSheet,"FilterRow");
			//propFun(activeSheet,"HyperLinkFun");
			//
			workbook.save(outputPath);
	}
	
	public static void processTemplateOne() {
		String outputPath = "output/sendforpoc_output.xlsx";
		 TableV3 dd = getDataSourcesFromXml(TableV3.class, "data/dataV3.xml");
			Parent ds = getDataSourcesFromXml(Parent.class, "data/sample-data.xml");
			Workbook.AddCustomFunction(new HyperLinkFunction());
			Workbook.AddCustomFunction(new FilterRowCondition());
			Workbook workbook= new Workbook();
			workbook.open(MyApp.class.getClassLoader().getResourceAsStream("xlsx/sendforpoc2.xlsx"));
			workbook.addDataSource("dd", dd);
			workbook.addDataSource("ds", ds);
			
			log.info("Process Template begin");
			workbook.processTemplate();
			
			log.info("Process Template complete");
			workbook.save(outputPath);
	}
	
	public static void propFun(IWorksheet activeSheet,String functionName) { 
		FindOptions fo = new FindOptions();
		fo.setLookIn(FindLookIn.Formulas);
		IRange usedRange = activeSheet.getUsedRange();
		IRange find = null;
		do
		{
			find = usedRange.find(functionName, find, fo);
			if(find!=null) {
					/**
					 * If we not call getValue then custom function will not get called
					 */
					System.out.println(find.getValue());
			}
		}while(find!=null);
		
	}
	

	public static <T extends Object> T getDataSourcesFromXml(Class<T> clazz,String filePath) {
		Object unmarshal = null;
		try {
			JAXBContext jaxbContext = JAXBContext.newInstance(clazz);
			Unmarshaller jaxbUnmarshaller = jaxbContext.createUnmarshaller();
			unmarshal = jaxbUnmarshaller.unmarshal(MyApp.class.getClassLoader().getResourceAsStream(filePath));
		} catch (JAXBException e) {
			log.error("ERROR-", ExceptionUtils.getStackTrace(e));
		}
		return clazz.cast(unmarshal);
	}
}
