package com.test.functions;

import com.grapecity.documents.excel.CustomFunction;
import com.grapecity.documents.excel.FunctionValueType;
import com.grapecity.documents.excel.ICalcContext;
import com.grapecity.documents.excel.IRange;
import com.grapecity.documents.excel.Parameter;


/**
 * param1-Address where we apply hyperLink
 * param2-It refer outside link like(webPage, email)
 * param3-It refer document/sheet address
 * param4-It refer description/name of hyperlink
 * param5-It refer text/value of address
 * 
 */
public class HyperLinkFunction extends CustomFunction {
        public HyperLinkFunction() {
            super("HyperLinkFun", FunctionValueType.Object,CreateParameters());
        }

        static Parameter[] CreateParameters()
        {
        Parameter[] parameters = new Parameter[254];
        for (int i = 0; i < 254; i++)
        {
        parameters[i] = new Parameter(FunctionValueType.Variant);
        }
        return parameters;
        }
        @Override
        public Object evaluate(Object[] arguments, ICalcContext context) {
        	IRange range = context.getWorksheet().getRange(context.getRow(),context.getColumn());
        	range.getHyperlinks().add(range,getValue(arguments,0), getValue(arguments,1), getValue(arguments,2),getValue(arguments,3));
        	//range.setValue(range.getValue());
            return range.getValue();
        }
        
        public String getValue(Object[] arguments,int index) {
        	if(arguments.length>index) {
        		if(arguments[index]==null) {
        			return null;
        		}
        		if("".equals(arguments[index].toString())) {
        			return null;
        		}
            	return arguments[index].toString();	
        	}else {
        		return null;
        	}
        }
}


        